//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "math.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "CPortCtl"
#pragma resource "*.dfm"

// (C) Fabrice Sincre ; fvrier 2008
// Borland Builder 5
// avec Composant TComPort (gestion RS232)
// Ce projet s'appuie sur le projet "carte d'acquisistion 7 voies (16F88)"


double vmin = 30.0 ;
double vmin0 = 30.0 ;
double vmax = 80.0;
double vmax0 = 80.0 ;
double deltat = 5.0 ;   // (80 - 30)/10

unsigned char tableau[1];
        // TX (RS232)  1 octet transmis vers le PIC (numro du canal : 0)
        // 1er octet transmis: tableau[0]

int numerocanal = 0;      // canal  chantilloner (0)

int resultatconversion ;    //(nb binaire 18 bits, converti en nb entier)
double tension ;            //   tension du canal 0 (en volts)

double vrefplus = 5.0;     // ADC Vref+ = 5 V
double vrefmoins = 0.0;    // ADC Vref- = 0 V


//---------------------------------------------------------------------------

TForm1 *Form1;


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

ProgressBar1->Brush->Color = clWhite;

}

//---------------------------------------------------------------------------


void __fastcall TForm1::Button7Click(TObject *Sender)
{
ComPort1->Connected=true;  // ouverture du port
Button7->Enabled=false;
Button8->Enabled=true;
Button6->Enabled=false;
Button1->Enabled=true;

Edit1 -> Enabled=true;
Edit2 -> Enabled=true;

EditTension0 -> Enabled=true;

}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
ComPort1->Connected=false;  // fermeture du port
Button7->Enabled=true;
Button8->Enabled=false;
Button6->Enabled=true;
Button1->Enabled=false;

Edit1 -> Enabled=false;
Edit2 -> Enabled=false;

EditTension0 -> Enabled=false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComPort1RxChar(TObject *Sender, int Count)
{
// on arrive ici quand on reoit des donnes du port COM (normalement toutes les 140 ms)

try
{

unsigned char *datarecu = new unsigned char [Count];
ComPort1->Read(datarecu, Count);
// Lit "Count" octet(s) prsent(s) dans le buffer d'entre et le(s) place dans "datarecu"
// Normalement, on reoit trois octets du PIC

        resultatconversion = datarecu[0]*256*256 + datarecu[1]*256 + datarecu[2];

        tension = (vrefplus - vrefmoins)*resultatconversion/(1023.0*256.0) + vrefmoins;
        if (tension < 50.0e-6) tension = 50.0e-6 ;

        if (numerocanal == 0)
        {
                // 5 V <=> 100 dB
                // 500 mV <=> 80 dB
                // 50 mV <=> 60 dB
                // 5 mV <=> 40 dB
                // 500 V <=> 20 dB
                // 50 V <=> 0 dB

                tension = 20.0*log10(tension/50.0e-6) ;

                EditTension0 -> Text =  FloatToStrF(tension,ffFixed,15,0);
                // arrondi  l'entier le plus proche
        }

ProgressBar1 -> Position =  tension + 0.5 ;  // arrondi  l'entier le plus proche

delete [] datarecu;
datarecu = NULL;
}

catch(...)
{
Application->MessageBox("Erreur de rception !","Erreur 03",MB_OK);
}


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
ComPort1->ShowSetupDialog();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonSchema1Click(TObject *Sender)
{
Form2shema1-> ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
// on arrive ici toutes les 140 ms

if (ComPort1->Connected==true)
{
        tableau[0]= numerocanal;
        ComPort1->Write(tableau, 1); // Ecrit 1 octet sur le port srie
}
}
//---------------------------------------------------------------------------




void __fastcall TForm1::ButtonSchema2Click(TObject *Sender)
{
Form3Schema2-> ShowModal();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button1Click(TObject *Sender)
{
try
{
vmax =(Edit1->Text).ToDouble(); //conversion de AnsiString en Double
vmin =(Edit2->Text).ToDouble(); //conversion de AnsiString en Double

}
catch(...)
{
vmax = vmax0;
vmin = vmin0;

Edit1->Text = FloatToStrF(vmax,ffFixed,15,1);
Edit2->Text = FloatToStrF(vmin,ffFixed,15,1);

Application->MessageBox("Valeur non valide !","Erreur 01",MB_OK);
}

if (vmax <= vmin)
{
        Application->MessageBox ("Le max. doit tre suprieur au min. !","Erreur 02",MB_OK);
        vmax = vmax0;
        vmin = vmin0;
}

vmax0 = vmax;
vmin0 = vmin;

deltat = (vmax - vmin)/10.0 ;

Edit1->Text = FloatToStrF(vmax,ffFixed,15,1);
Edit2->Text = FloatToStrF(vmin,ffFixed,15,1);

Labelx0 -> Caption = FloatToStrF(vmin,ffFixed,15,1);
Labelx1 -> Caption = FloatToStrF(vmin + 1.0*deltat,ffFixed,15,1);
Labelx2 -> Caption = FloatToStrF(vmin + 2.0*deltat,ffFixed,15,1);
Labelx3 -> Caption = FloatToStrF(vmin + 3.0*deltat,ffFixed,15,1);
Labelx4 -> Caption = FloatToStrF(vmin + 4.0*deltat,ffFixed,15,1);
Labelx5 -> Caption = FloatToStrF(vmin + 5.0*deltat,ffFixed,15,1);
Labelx6 -> Caption = FloatToStrF(vmin + 6.0*deltat,ffFixed,15,1);
Labelx7 -> Caption = FloatToStrF(vmin + 7.0*deltat,ffFixed,15,1);
Labelx8 -> Caption = FloatToStrF(vmin + 8.0*deltat,ffFixed,15,1);
Labelx9 -> Caption = FloatToStrF(vmin + 9.0*deltat,ffFixed,15,1);
Labelx10 -> Caption = FloatToStrF(vmin + 10.0*deltat,ffFixed,15,1);

ProgressBar1 -> Min = vmin ;
ProgressBar1 -> Max = vmax ;
ProgressBar1 -> Position = tension + 0.5;  // arrondi  l'entier le plus proche
}
//---------------------------------------------------------------------------

